%global _python_bytecompile_extra 0

Name:           pyproject-rpm-macros
Summary:        RPM macros for PEP 517 Python packages
License:        MIT
Group:          Development/Python

%bcond_with tests

# Keep the version at zero and increment only release
Version:        0
Release:        %mkrel 6

# Macro files
Source001:      macros.pyproject

# Implementation files
Source101:      pyproject_buildrequires.py
Source102:      pyproject_save_files.py
Source103:      pyproject_convert.py
Source104:      pyproject_preprocess_record.py

# Tests
Source201:      test_pyproject_buildrequires.py
Source202:      test_pyproject_save_files.py

# Test data
Source301:      pyproject_buildrequires_testcases.yaml
Source302:      pyproject_save_files_test_data.yaml
Source303:      test_RECORD

# Metadata
Source901:      README.md
Source902:      LICENSE

URL:            https://src.fedoraproject.org/rpms/pyproject-rpm-macros

BuildArch:      noarch

%if %{with tests}
BuildRequires: python3dist(pytest)
BuildRequires: python3dist(pyyaml)
BuildRequires: python3dist(packaging)
BuildRequires: python3dist(pip)
BuildRequires: python3dist(setuptools)
BuildRequires: python3dist(toml)
BuildRequires: python3dist(tox-current-env) >= 0.0.3
BuildRequires: python3dist(wheel)
%endif

Requires:	python3dist(packaging)
Requires:	python3dist(pip) >= 19
Requires:	python3dist(wheel)

%description
This is a provisional implementation of pyproject RPM macros for Fedora 30+.
These macros are useful for packaging Python projects that use the PEP 517
pyproject.toml file, which specifies the package's build dependencies
(including the build system, such as setuptools, flit or poetry).


%prep
# Not strictly necessary but allows working on file names instead
# of source numbers in install section
%setup -c -T
cp -p %{sources} .

%build
# nothing to do, sources are not buildable

%install
mkdir -p %{buildroot}%{_rpmmacrodir}
mkdir -p %{buildroot}%{_rpmconfigdir}/redhat
install -m 644 macros.pyproject %{buildroot}%{_rpmmacrodir}/
install -m 644 pyproject_buildrequires.py %{buildroot}%{_rpmconfigdir}/redhat/
install -m 644 pyproject_convert.py %{buildroot}%{_rpmconfigdir}/redhat/
install -m 644 pyproject_save_files.py  %{buildroot}%{_rpmconfigdir}/redhat/
install -m 644 pyproject_preprocess_record.py %{buildroot}%{_rpmconfigdir}/redhat/

%if %{with tests}
%check
export HOSTNAME="rpmbuild"  # to speedup tox in network-less mock, see rhbz#1856356
%{python3} -m pytest -vv --doctest-modules
%endif


%files
%{_rpmmacrodir}/macros.pyproject
%{_rpmconfigdir}/redhat/pyproject_buildrequires.py
%{_rpmconfigdir}/redhat/pyproject_convert.py
%{_rpmconfigdir}/redhat/pyproject_save_files.py
%{_rpmconfigdir}/redhat/pyproject_preprocess_record.py

%doc README.md
%license LICENSE


%changelog
* Wed Oct 07 2020 wally <wally> 0-6.mga8
+ Revision: 1632608
- require python3dist(wheel)

* Wed Oct 07 2020 wally <wally> 0-5.mga8
+ Revision: 1632603
- require python3dist(packaging) and python3dist(pip) >= 19

* Wed Oct 07 2020 wally <wally> 0-4.mga8
+ Revision: 1632583
- sync with Fedora

* Wed May 20 2020 joequant <joequant> 0-3.mga8
+ Revision: 1586290
- rebuild

* Tue May 19 2020 joequant <joequant> 0-2.mga8
+ Revision: 1586099
- redo to remove complex requires

* Mon May 18 2020 joequant <joequant> 0-1.mga8
+ Revision: 1586090
- imported package pyproject-rpm-macros

